# TInstanceRenderable Class Reference
[Data Structures]

Inheritance diagram for TInstanceRenderable:

List of all members.

## Public Member Functions
void | SetInstance (I3DShInstance *instance)
TRenderableFlags MCCOMAPI | GetRenderableFlags () const
MCCOMErr MCCOMAPI | SetRenderableFlags (const TRenderableFlags flags)
I3DShRenderable::EType MCCOMAPI | GetGeometryType () const
MCCOMErr MCCOMAPI | GetFMesh (real lod, FacetMesh **amesh)
virtual void MCCOMAPI | GetBoundingBox (TBBox3D &bb)
uint32 MCCOMAPI | GetUVSpaceCount ()
MCCOMErr MCCOMAPI | GetInstance (I3DShInstance **instance)
I3DShInstance *MCCOMAPI | GetInstance ()
virtual ELODParamType MCCOMAPI | GetLODParamType () const
virtual boolean MCCOMAPI | GetRecommendedTextureSize (uint32 uvSpaceID, uint32 channelIndex, uint32 &width, uint32 &height) const
| Calculate the intrinsic appropriate texture size.
virtual void MCCOMAPI | GetRelevantTextureBucketCache (uint32 uvSpaceID, uint32 channelIndex, boolean allowMultiplierModification, IShTextureMapBucketCache **outTextureMapFile) const
| Get the texture map file associated to the specified shading domain.
## Static Public Member Functions
static void | Create (TInstanceRenderable **instanceRenderable)
## Protected Member Functions
| TInstanceRenderable ()
| TInstanceRenderable (I3DShInstance *instance)
virtual MCCOMErr MCCOMAPI | SelfGetFlatennedTexturesAsync (uint32 uvSpaceID, UVMaps &maps, TextureAvailableProc proc, void *privData, TMCRealRect *range=nil) const
virtual MCCOMErr MCCOMAPI | SelfGetShadingApproximation (TShadingApproximation &shadingApprox, uint32 uvSpaceID) const
## Private Attributes
TRenderableFlags | fFlags
I3DShInstance * | fInstance
TMCClassArray < TShadingApproximation > | fShadingApproximation
TMCArray< boolean > | fShadingApproximationValid

## Constructor & Destructor Documentation

TInstanceRenderable::TInstanceRenderable | ( |  | ) | `[protected]`

TInstanceRenderable::TInstanceRenderable | ( | I3DShInstance * | instance | ) | `[protected]`

## Member Function Documentation

static void TInstanceRenderable::Create | ( | TInstanceRenderable ** | instanceRenderable | ) | `[static]`

virtual void MCCOMAPI TInstanceRenderable::GetBoundingBox | ( | TBBox3D & | bb | ) | `[virtual]`

Returns the bounding box of the renderable in local coordinates (for triangle meshes).

Parameters:

  | bb | The bounding box that is returned.

Reimplemented from TCountedRenderable.

MCCOMErr MCCOMAPI TInstanceRenderable::GetFMesh | ( | real | lod,
|  | FacetMesh ** | amesh |
| ) |  |  | `[virtual]`

Returns a pointer to the triangle mesh contained in this renderable (see GetGeometryType()).

Parameters:

  | lod | The lod that is requested.
  | amesh | A pointer to the mesh that is returned.

Reimplemented from TCountedRenderable.

I3DShRenderable::EType MCCOMAPI TInstanceRenderable::GetGeometryType | ( |  | ) | const`[virtual]`

Returns the type of geometry that should be rendered (points, segments or triangles...)

Reimplemented from TCountedRenderable.

I3DShInstance* MCCOMAPI TInstanceRenderable::GetInstance | ( |  | ) | `[inline]`

MCCOMErr MCCOMAPI TInstanceRenderable::GetInstance | ( | I3DShInstance ** | instance | ) | `[inline, virtual]`

Returns a pointer to the instance that corresponds to the renderable. Note that it can be NULL if the renderable has no instance

Parameters:

  | instance | A pointer to the instance.

Reimplemented from TCountedRenderable.

virtual ELODParamType MCCOMAPI TInstanceRenderable::GetLODParamType | ( |  | ) | const`[virtual]`

Returns:
  The type of information used to calculate the appropriate LOD

Reimplemented from TCountedRenderable.

virtual boolean MCCOMAPI TInstanceRenderable::GetRecommendedTextureSize | ( | uint32 | uvSpaceID,
|  | uint32 | channelIndex,
|  | uint32 & | width,
|  | uint32 & | height |
| ) |  |  | const`[virtual]`

Calculate the intrinsic appropriate texture size.

Reimplemented from TCountedRenderable.

virtual void MCCOMAPI TInstanceRenderable::GetRelevantTextureBucketCache | ( | uint32 | uvSpaceID,
|  | uint32 | channelIndex,
|  | boolean | allowMultiplierModification,
|  | IShTextureMapBucketCache ** | outTextureMapFile |
| ) |  |  | const`[virtual]`

Get the texture map file associated to the specified shading domain.

Reimplemented from TCountedRenderable.

TRenderableFlags MCCOMAPI TInstanceRenderable::GetRenderableFlags | ( |  | ) | const`[virtual]`

Returns the flags associated with this renderable. See TRenderableFlags for more info.

Reimplemented from TCountedRenderable.

uint32 MCCOMAPI TInstanceRenderable::GetUVSpaceCount | ( |  | ) | `[virtual]`

Returns the number of shading domaine (uv space) on the primitive.

Reimplemented from TCountedRenderable.

virtual MCCOMErr MCCOMAPI TInstanceRenderable::SelfGetFlatennedTexturesAsync | ( | uint32 | uvSpaceID,
|  | UVMaps & | maps,
|  | TextureAvailableProc | proc,
|  | void * | privData,
|  | TMCRealRect * | range = `nil` |
| ) |  |  | const`[protected, virtual]`

Reimplemented from TCountedRenderable.

virtual MCCOMErr MCCOMAPI TInstanceRenderable::SelfGetShadingApproximation | ( | TShadingApproximation & | shadingApprox,
|  | uint32 | uvSpaceID |
| ) |  |  | const`[protected, virtual]`

Reimplemented from TCountedRenderable.

void TInstanceRenderable::SetInstance | ( | I3DShInstance * | instance | ) |

MCCOMErr MCCOMAPI TInstanceRenderable::SetRenderableFlags | ( | const TRenderableFlags | flags | ) | `[inline, virtual]`

Sets the flags associated with this renderable.

Parameters:

  | flags | The flags.

Reimplemented from TCountedRenderable.

## Member Data Documentation

TRenderableFlags TInstanceRenderable::fFlags`[private]`

I3DShInstance* TInstanceRenderable::fInstance`[private]`

TMCClassArray< TShadingApproximation> TInstanceRenderable::fShadingApproximation`[mutable, private]`

TMCArray<boolean> TInstanceRenderable::fShadingApproximationValid`[mutable, private]`

The documentation for this class was generated from the following file:

- CountedRenderable.h